diff -cprN head/src/backend/catalog/Makefile work/src/backend/catalog/Makefile
*** head/src/backend/catalog/Makefile	2009-10-08 07:14:16.000000000 +0900
--- work/src/backend/catalog/Makefile	2009-11-05 11:55:00.573160135 +0900
*************** POSTGRES_BKI_SRCS = $(addprefix $(top_sr
*** 37,43 ****
  	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
  	pg_ts_parser.h pg_ts_template.h \
  	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
! 	pg_default_acl.h \
  	toasting.h indexing.h \
      )
  
--- 37,43 ----
  	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
  	pg_ts_parser.h pg_ts_template.h \
  	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
! 	pg_default_acl.h pg_partition.h \
  	toasting.h indexing.h \
      )
  
diff -cprN head/src/backend/catalog/dependency.c work/src/backend/catalog/dependency.c
*** head/src/backend/catalog/dependency.c	2009-10-06 04:24:35.000000000 +0900
--- work/src/backend/catalog/dependency.c	2009-11-05 11:55:00.573886532 +0900
***************
*** 41,46 ****
--- 41,47 ----
  #include "catalog/pg_opclass.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_opfamily.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_rewrite.h"
  #include "catalog/pg_tablespace.h"
*************** static const Oid object_classes[MAX_OCLA
*** 149,155 ****
  	ForeignDataWrapperRelationId,	/* OCLASS_FDW */
  	ForeignServerRelationId,	/* OCLASS_FOREIGN_SERVER */
  	UserMappingRelationId,		/* OCLASS_USER_MAPPING */
! 	DefaultAclRelationId		/* OCLASS_DEFACL */
  };
  
  
--- 150,157 ----
  	ForeignDataWrapperRelationId,	/* OCLASS_FDW */
  	ForeignServerRelationId,	/* OCLASS_FOREIGN_SERVER */
  	UserMappingRelationId,		/* OCLASS_USER_MAPPING */
! 	DefaultAclRelationId,		/* OCLASS_DEFACL */
! 	PartitionRelationId			/* OCLASS_PARTITION */
  };
  
  
*************** doDeletion(const ObjectAddress *object)
*** 1143,1148 ****
--- 1145,1154 ----
  			RemoveDefaultACLById(object->objectId);
  			break;
  
+ 		case OCLASS_PARTITION:
+ 			RemovePartitionById(object->objectId);
+ 			break;
+ 
  		default:
  			elog(ERROR, "unrecognized object class: %u",
  				 object->classId);
*************** getObjectClass(const ObjectAddress *obje
*** 2066,2071 ****
--- 2072,2081 ----
  		case DefaultAclRelationId:
  			Assert(object->objectSubId == 0);
  			return OCLASS_DEFACL;
+ 
+ 		case PartitionRelationId:
+ 			Assert(object->objectSubId == 0);
+ 			return OCLASS_PARTITION;
  	}
  
  	/* shouldn't get here */
*************** getObjectDescription(const ObjectAddress
*** 2671,2676 ****
--- 2681,2730 ----
  				break;
  			}
  
+ 		case OCLASS_PARTITION:
+ 			{
+ 				Relation	rel;
+ 				ScanKeyData skey[1];
+ 				SysScanDesc rcscan;
+ 				HeapTuple	tup;
+ 				Form_pg_partition partition;
+ 
+ 				rel = heap_open(PartitionRelationId, AccessShareLock);
+ 
+ 				ScanKeyInit(&skey[0],
+ 							Anum_pg_partition_partrelid,
+ 							BTEqualStrategyNumber, F_OIDEQ,
+ 							ObjectIdGetDatum(object->objectId));
+ 
+ 				rcscan = systable_beginscan(rel, PartitionRelidIndexId,
+ 											true, SnapshotNow, 1, skey);
+ 
+ 				tup = systable_getnext(rcscan);
+ 
+ 				if (!HeapTupleIsValid(tup))
+ 					elog(ERROR, "could not find tuple for partition %u",
+ 						 object->objectId);
+ 
+ 				partition = (Form_pg_partition) GETSTRUCT(tup);
+ 
+ 				switch (partition->partkind)
+ 				{
+ 					case PARTITION_BY_RANGE:
+ 						appendStringInfo(&buffer, _("range partition"));
+ 						break;
+ 					case PARTITION_BY_LIST:
+ 						appendStringInfo(&buffer, _("list partition"));
+ 						break;
+ 					default:
+ 						appendStringInfo(&buffer, _("partition"));
+ 						break;
+ 				}
+ 
+ 				systable_endscan(rcscan);
+ 				heap_close(rel, AccessShareLock);
+ 				break;
+ 			}
+ 
  		default:
  			appendStringInfo(&buffer, "unrecognized object %u %u %d",
  							 object->classId,
diff -cprN head/src/backend/catalog/heap.c work/src/backend/catalog/heap.c
*** head/src/backend/catalog/heap.c	2009-10-06 04:24:35.000000000 +0900
--- work/src/backend/catalog/heap.c	2009-11-05 11:55:00.574839091 +0900
***************
*** 43,48 ****
--- 43,49 ----
  #include "catalog/pg_constraint.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_namespace.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_tablespace.h"
  #include "catalog/pg_type.h"
*************** RemoveStatistics(Oid relid, AttrNumber a
*** 2361,2366 ****
--- 2362,2392 ----
  
  
  /*
+  * Remove a pg_partition entry
+  */
+ void
+ RemovePartitionById(Oid relid)
+ {
+ 	Relation	rel;
+ 	HeapTuple	tup;
+ 
+ 	rel = heap_open(PartitionRelationId, RowExclusiveLock);
+ 
+ 	tup = SearchSysCache(PARTITIONKEY,
+ 						 ObjectIdGetDatum(relid),
+ 						 0, 0, 0);
+ 	if (!HeapTupleIsValid(tup))
+ 		elog(ERROR, "cache lookup failed for partition %u", relid);
+ 
+ 	simple_heap_delete(rel, &tup->t_self);
+ 
+ 	ReleaseSysCache(tup);
+ 
+ 	heap_close(rel, RowExclusiveLock);
+ }
+ 
+ 
+ /*
   * RelationTruncateIndexes - truncate all indexes associated
   * with the heap relation to zero tuples.
   *
diff -cprN head/src/backend/commands/tablecmds.c work/src/backend/commands/tablecmds.c
*** head/src/backend/commands/tablecmds.c	2009-10-15 07:14:21.000000000 +0900
--- work/src/backend/commands/tablecmds.c	2009-11-05 20:07:25.137312000 +0900
***************
*** 32,37 ****
--- 32,39 ----
  #include "catalog/pg_inherits_fn.h"
  #include "catalog/pg_namespace.h"
  #include "catalog/pg_opclass.h"
+ #include "catalog/pg_operator.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_tablespace.h"
  #include "catalog/pg_trigger.h"
  #include "catalog/pg_type.h"
***************
*** 65,72 ****
--- 67,76 ----
  #include "storage/bufmgr.h"
  #include "storage/lmgr.h"
  #include "storage/smgr.h"
+ #include "tcop/utility.h"
  #include "utils/acl.h"
  #include "utils/builtins.h"
+ #include "utils/datum.h"
  #include "utils/fmgroids.h"
  #include "utils/inval.h"
  #include "utils/lsyscache.h"
*************** typedef struct NewColumnValue
*** 174,179 ****
--- 178,193 ----
  } NewColumnValue;
  
  /*
+  * PartitionValues - store partition values.
+  */
+ typedef struct PartitionValues
+ {
+ 	Oid		relid;
+ 	int		nvalues;
+ 	Datum  *values;
+ } PartitionValues;
+ 
+ /*
   * Error-reporting support for RemoveRelations
   */
  struct dropmsgstrings
*************** static void MergeAttributesIntoExisting(
*** 230,236 ****
  static void MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel);
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static void StoreCatalogInheritance1(Oid relationId, Oid parentOid,
! 						 int16 seqNumber, Relation inhRelation);
  static int	findAttrByName(const char *attributeName, List *schema);
  static void setRelhassubclassInRelation(Oid relationId, bool relhassubclass);
  static void AlterIndexNamespaces(Relation classRel, Relation rel,
--- 244,250 ----
  static void MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel);
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static void StoreCatalogInheritance1(Oid relationId, Oid parentOid,
! 					int16 seqNumber, ArrayType *values, Relation inhRelation);
  static int	findAttrByName(const char *attributeName, List *schema);
  static void setRelhassubclassInRelation(Oid relationId, bool relhassubclass);
  static void AlterIndexNamespaces(Relation classRel, Relation rel,
*************** static void ATExecEnableDisableTrigger(R
*** 329,339 ****
  						   char fires_when, bool skip_system);
  static void ATExecEnableDisableRule(Relation rel, char *rulename,
  						char fires_when);
! static void ATExecAddInherit(Relation rel, RangeVar *parent);
  static void ATExecDropInherit(Relation rel, RangeVar *parent);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  				   ForkNumber forkNum, bool istemp);
  static const char *storage_name(char c);
  
  
  /* ----------------------------------------------------------------
--- 343,358 ----
  						   char fires_when, bool skip_system);
  static void ATExecEnableDisableRule(Relation rel, char *rulename,
  						char fires_when);
! static void ATExecAddInherit(List **wqueue, AlteredTableInfo *tab, Relation rel, AddInherit *def);
  static void ATExecDropInherit(Relation rel, RangeVar *parent);
+ static void ATExecPartitionBy(Relation rel, PartitionBy *defs);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  				   ForkNumber forkNum, bool istemp);
  static const char *storage_name(char c);
+ static ArrayType *AddPartitionConstraint(List **wqueue, AlteredTableInfo *tab,
+ 		AddInherit *def, Relation inhrel, Relation parent, Relation child);
+ static Datum *evaluate_values(Oid typid, int typlen, bool typbyval,
+ 							  List *values, int *length);
  
  
  /* ----------------------------------------------------------------
*************** StoreCatalogInheritance(Oid relationId, 
*** 1767,1773 ****
  	{
  		Oid			parentOid = lfirst_oid(entry);
  
! 		StoreCatalogInheritance1(relationId, parentOid, seqNumber, relation);
  		seqNumber++;
  	}
  
--- 1786,1792 ----
  	{
  		Oid			parentOid = lfirst_oid(entry);
  
! 		StoreCatalogInheritance1(relationId, parentOid, seqNumber, NULL, relation);
  		seqNumber++;
  	}
  
*************** StoreCatalogInheritance(Oid relationId, 
*** 1779,1786 ****
   * of parentOid.  inhRelation is the already-opened pg_inherits catalog.
   */
  static void
! StoreCatalogInheritance1(Oid relationId, Oid parentOid,
! 						 int16 seqNumber, Relation inhRelation)
  {
  	TupleDesc	desc = RelationGetDescr(inhRelation);
  	Datum		datum[Natts_pg_inherits];
--- 1798,1805 ----
   * of parentOid.  inhRelation is the already-opened pg_inherits catalog.
   */
  static void
! StoreCatalogInheritance1(Oid relationId, Oid parentOid, int16 seqNumber,
! 						 ArrayType *values, Relation inhRelation)
  {
  	TupleDesc	desc = RelationGetDescr(inhRelation);
  	Datum		datum[Natts_pg_inherits];
*************** StoreCatalogInheritance1(Oid relationId,
*** 1795,1804 ****
--- 1814,1825 ----
  	datum[0] = ObjectIdGetDatum(relationId);	/* inhrelid */
  	datum[1] = ObjectIdGetDatum(parentOid);		/* inhparent */
  	datum[2] = Int16GetDatum(seqNumber);		/* inhseqno */
+ 	datum[3] = PointerGetDatum(values);			/* inhvalues */
  
  	nullarr[0] = false;
  	nullarr[1] = false;
  	nullarr[2] = false;
+ 	nullarr[3] = (values == NULL);
  
  	tuple = heap_form_tuple(desc, datum, nullarr);
  
*************** RenameRelationInternal(Oid myrelid, cons
*** 2234,2239 ****
--- 2255,2279 ----
  }
  
  /*
+  * CREATE PARTITION partition ON table
+  */
+ void
+ CreatePartition(CreatePartitionStmt *stmt, const char *queryString)
+ {
+ 	List		   *stmts;
+ 	ListCell	   *cell;
+ 
+ 	stmts = transformCreatePartition(stmt->def, stmt->parent);
+ 
+ 	foreach(cell, stmts)
+ 	{
+ 		ProcessUtility((Node *) lfirst(cell),
+ 					   queryString, NULL, false, NULL, NULL);
+ 		CommandCounterIncrement();
+ 	}
+ }
+ 
+ /*
   * Disallow ALTER TABLE (and similar commands) when the current backend has
   * any open reference to the target table besides the one just acquired by
   * the calling command; this implies there's an open cursor or active plan.
*************** ATPrepCmd(List **wqueue, Relation rel, A
*** 2579,2584 ****
--- 2619,2628 ----
  			/* No command-specific prep needed */
  			pass = AT_PASS_MISC;
  			break;
+ 		case AT_AddInherit:		/* INHERIT [AS PARTITION] */
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_ADD_CONSTR;
+ 			break;
  		case AT_EnableTrig:		/* ENABLE TRIGGER variants */
  		case AT_EnableAlwaysTrig:
  		case AT_EnableReplicaTrig:
*************** ATPrepCmd(List **wqueue, Relation rel, A
*** 2591,2598 ****
  		case AT_EnableAlwaysRule:
  		case AT_EnableReplicaRule:
  		case AT_DisableRule:
! 		case AT_AddInherit:		/* INHERIT / NO INHERIT */
! 		case AT_DropInherit:
  			ATSimplePermissions(rel, false);
  			/* These commands never recurse */
  			/* No command-specific prep needed */
--- 2635,2642 ----
  		case AT_EnableAlwaysRule:
  		case AT_EnableReplicaRule:
  		case AT_DisableRule:
! 		case AT_DropInherit:	/* NO INHERIT */
! 		case AT_PartitionBy:	/* PARTITION BY / NO PARTITION */
  			ATSimplePermissions(rel, false);
  			/* These commands never recurse */
  			/* No command-specific prep needed */
*************** ATExecCmd(List **wqueue, AlteredTableInf
*** 2833,2843 ****
  			break;
  
  		case AT_AddInherit:
! 			ATExecAddInherit(rel, (RangeVar *) cmd->def);
  			break;
  		case AT_DropInherit:
  			ATExecDropInherit(rel, (RangeVar *) cmd->def);
  			break;
  		default:				/* oops */
  			elog(ERROR, "unrecognized alter table type: %d",
  				 (int) cmd->subtype);
--- 2877,2890 ----
  			break;
  
  		case AT_AddInherit:
! 			ATExecAddInherit(wqueue, tab, rel, (AddInherit *) cmd->def);
  			break;
  		case AT_DropInherit:
  			ATExecDropInherit(rel, (RangeVar *) cmd->def);
  			break;
+ 		case AT_PartitionBy:	/* PARTITION BY / NO PARTITION */
+ 			ATExecPartitionBy(rel, (PartitionBy *) cmd->def);
+ 			break;
  		default:				/* oops */
  			elog(ERROR, "unrecognized alter table type: %d",
  				 (int) cmd->subtype);
*************** ATExecAlterColumnType(AlteredTableInfo *
*** 6164,6169 ****
--- 6211,6221 ----
  					 getObjectDescription(&foundObject));
  				break;
  
+ 			case OCLASS_PARTITION:
+ 				/* TODO: recreate all partitions */
+ 				elog(ERROR, "cannot change partition key");
+ 				break;
+ 
  			default:
  				elog(ERROR, "unrecognized object class: %u",
  					 foundObject.classId);
*************** ATExecEnableDisableRule(Relation rel, ch
*** 7138,7145 ****
   * same data types and expressions.
   */
  static void
! ATExecAddInherit(Relation child_rel, RangeVar *parent)
  {
  	Relation	parent_rel,
  				catalogRelation;
  	SysScanDesc scan;
--- 7190,7199 ----
   * same data types and expressions.
   */
  static void
! ATExecAddInherit(List **wqueue, AlteredTableInfo *tab,
! 				 Relation child_rel, AddInherit *def)
  {
+ 	RangeVar   *parent = def->parent;
  	Relation	parent_rel,
  				catalogRelation;
  	SysScanDesc scan;
*************** ATExecAddInherit(Relation child_rel, Ran
*** 7147,7152 ****
--- 7201,7207 ----
  	HeapTuple	inheritsTuple;
  	int32		inhseqno;
  	List	   *children;
+ 	ArrayType  *inhvalues;
  
  	/*
  	 * AccessShareLock on the parent is what's obtained during normal CREATE
*************** ATExecAddInherit(Relation child_rel, Ran
*** 7238,7251 ****
--- 7293,7331 ----
  	/* Match up the constraints and bump coninhcount as needed */
  	MergeConstraintsIntoExisting(child_rel, parent_rel);
  
+ 	/* Add CHECK constraint for partition */
+ 	if (def->kind)
+ 		inhvalues = AddPartitionConstraint(wqueue, tab, def,
+ 						catalogRelation, parent_rel, child_rel);
+ 	else
+ 		inhvalues = NULL;
+ 
  	/*
  	 * OK, it looks valid.	Make the catalog entries that show inheritance.
  	 */
  	StoreCatalogInheritance1(RelationGetRelid(child_rel),
  							 RelationGetRelid(parent_rel),
  							 inhseqno + 1,
+ 							 inhvalues,
  							 catalogRelation);
  
+ #ifdef NOT_USED
+ 	/* XXX: Do we need to add depencency to inherit object? */
+ 	if (def->kind)
+ 	{
+ 		ObjectAddress	partitionObj;
+ 		ObjectAddress	inheritsObj;
+ 
+ 		partitionObj.classId = PartitionRelationId;
+ 		partitionObj.objectId = RelationGetRelid(child_rel);
+ 		partitionObj.objectSubId = 0;
+ 		inheritsObj.classId = InheritsRelationId;
+ 		inheritsObj.objectId = RelationGetRelid(parent_rel);
+ 		inheritsObj.objectSubId = RelationGetRelid(child_rel);
+ 		recordDependencyOn(&childObj, &partitionObj, DEPENDENCY_NORMAL);
+ 	}
+ #endif
+ 
  	/* Now we're done with pg_inherits */
  	heap_close(catalogRelation, RowExclusiveLock);
  
*************** ATExecAddInherit(Relation child_rel, Ran
*** 7254,7259 ****
--- 7334,7649 ----
  }
  
  /*
+  * AddPartitionConstraint - Add check constraint for partition.
+  */
+ static ArrayType *
+ AddPartitionConstraint(List **wqueue, AlteredTableInfo *tab, AddInherit *def,
+ 					   Relation inhrel, Relation parent, Relation child)
+ {
+ 	SysScanDesc			scan;
+ 	ScanKeyData			key;
+ 	HeapTuple			tp;
+ 	Oid					opno;
+ 	Oid					oprcode;
+ 	Form_pg_operator	optup;
+ 	char				kind;
+ 	bool				isNull;
+ 	Datum				datum;
+ 	Node			   *partkey;
+ 	List			   *partopr;
+ 	FmgrInfo			opfn;
+ 	Oid					elmtype;
+ 	int16				elmlen;
+ 	bool				elmbyval;
+ 	char				elmalign;
+ 	Node			   *check_expr;
+ 	Datum			   *values;
+ 	int					nvalues;
+ 	List			   *partitions = NIL;
+ 
+ 	/* Get partition key and operator. */
+ 	tp = SearchSysCache(PARTITIONKEY,
+ 						ObjectIdGetDatum(RelationGetRelid(parent)),
+ 						0, 0, 0);
+ 	if (!HeapTupleIsValid(tp))
+ 		elog(ERROR, "relation \"%s.%s\" has no partition key",
+ 			get_namespace_name(RelationGetNamespace(parent)),
+ 			RelationGetRelationName(parent));
+ 
+ 	kind = DatumGetChar(SysCacheGetAttr(PARTITIONKEY, tp,
+ 							Anum_pg_partition_partkind, &isNull));
+ 	opno = DatumGetObjectId(SysCacheGetAttr(PARTITIONKEY, tp,
+ 							Anum_pg_partition_partopr, &isNull));
+ 	datum = SysCacheGetAttr(PARTITIONKEY, tp,
+ 							Anum_pg_partition_partkey, &isNull);
+ 	ReleaseSysCache(tp);
+ 
+ 	if (kind != def->kind)
+ 		elog(ERROR, "cannot add partition '%c' to relation \"%s.%s\" partitioned with '%c'",
+ 			def->kind,
+ 			get_namespace_name(RelationGetNamespace(parent)),
+ 			RelationGetRelationName(parent),
+ 			kind);
+ 
+ 	/* Get partition key and operator. */
+ 	tp = SearchSysCache(OPEROID,
+ 						ObjectIdGetDatum(opno),
+ 						0, 0, 0);
+ 	if (!HeapTupleIsValid(tp))
+ 		elog(ERROR, "cache lookup failed for operator %u", opno);
+ 	optup = (Form_pg_operator) GETSTRUCT(tp);
+ 	elmtype = optup->oprleft;
+ 	oprcode = optup->oprcode;
+ 	partopr = list_make2(makeString(get_namespace_name(optup->oprnamespace)),
+ 						makeString(pstrdup(NameStr(optup->oprname))));
+ 	ReleaseSysCache(tp);
+ 
+ 	/* Get partition key and operator. */
+ 	partkey = stringToNode(TextDatumGetCString(datum));
+ 	fmgr_info(oprcode, &opfn);
+ 	get_typlenbyvalalign(elmtype, &elmlen, &elmbyval, &elmalign);
+ 
+ 	/* Gather values from existing paritition. */
+ 	ScanKeyInit(&key,
+ 				Anum_pg_inherits_inhparent,
+ 				BTEqualStrategyNumber, F_OIDEQ,
+ 				ObjectIdGetDatum(RelationGetRelid(parent)));
+ 	scan = systable_beginscan(inhrel, InvalidOid, false, SnapshotNow, 1, &key);
+ 
+ 	while (HeapTupleIsValid(tp = systable_getnext(scan)))
+ 	{
+ 		Form_pg_inherits inh = (Form_pg_inherits) GETSTRUCT(tp);
+ 
+ 		/* gather existing partition values */
+ 		Datum	datum;
+ 		bool	isnull;
+ 
+ 		datum = heap_getattr(tp, Anum_pg_inherits_inhvalues,
+ 						 RelationGetDescr(inhrel), &isnull);
+ 		if (isnull)
+ 		{
+ 			if (def->values == NIL)
+ 				elog(ERROR, "duplicated overflow partition");
+ 			else if (def->kind == PARTITION_BY_LIST)
+ 				elog(ERROR, "cannot add list partition to relation that has overflow partition");
+ 		}
+ 		else
+ 		{
+ 			ArrayType		   *array;
+ 			PartitionValues	   *part;
+ 
+ 			array = DatumGetArrayTypePCopy(datum);
+ 
+ 			part = (PartitionValues *) palloc(sizeof(PartitionValues));
+ 			part->relid = inh->inhrelid;
+ 			deconstruct_array(array, elmtype, elmlen, elmbyval, elmalign,
+ 							  &part->values, NULL, &part->nvalues);
+ 
+ 			partitions = lappend(partitions, part);
+ 		}
+ 	}
+ 	systable_endscan(scan);
+ 
+ 	/* Convert expressions to datum array. */
+ 	values = evaluate_values(elmtype, elmlen, elmbyval, def->values, &nvalues);
+ 
+ 	/* ALTER TABLE ... ADD CHECK */
+ 	switch (def->kind)
+ 	{
+ 		case PARTITION_BY_RANGE:
+ 		{
+ 			PartitionValues	   *largest = NULL;
+ 			Node			   *lt_expr = NULL;
+ 			Node			   *ge_expr = NULL;
+ 			ListCell		   *cell;
+ 
+ 			/* Find partition with largest upper value. */
+ 			foreach(cell, partitions)
+ 			{
+ 				PartitionValues *part = (PartitionValues *) lfirst(cell);
+ 
+ 				/* overflow partition is the largest */
+ 				if (largest == NULL || part->nvalues < 0 ||
+ 					DatumGetBool(FunctionCall2(&opfn, largest->values[0], part->values[0])))
+ 					largest = part;
+ 			}
+ 
+ 			if (largest)
+ 			{
+ 				/* TODO: support spliting existing partition */
+ 				if (nvalues > 0 &&
+ 					(largest->nvalues < 0 || !DatumGetBool(FunctionCall2(
+ 						&opfn, largest->values[0], values[0]))))
+ 					elog(ERROR, "cannot split existing partition");
+ 
+ 				/* NOT (key < lower) */
+ 				ge_expr =
+ 					(Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
+ 						(Node *) makeA_Expr(AEXPR_OP, partopr, partkey,
+ 							(Node *) makeConst(elmtype, -1, elmlen,
+ 								largest->values[0], false, elmbyval), -1), -1);
+ 			}
+ 
+ 			/* key < upper */
+ 			if (nvalues > 0)
+ 				lt_expr = (Node *) makeA_Expr(
+ 					AEXPR_OP, partopr, partkey, linitial(def->values), -1);
+ 
+ 			if (ge_expr == NULL)		/* key < upper */
+ 				check_expr = lt_expr;
+ 			else if (lt_expr == NULL)	/* NOT (key < lower) */
+ 				check_expr = ge_expr;
+ 			else					/* NOT (key < lower) AND key < upper */
+ 				check_expr = (Node *) makeA_Expr(
+ 					AEXPR_AND, NIL, ge_expr, lt_expr, -1);
+ 			break;
+ 		}
+ 		case PARTITION_BY_LIST:
+ 		{
+ 			ListCell   *cell;
+ 			int			i;
+ 			int			j;
+ 
+ 			if (nvalues > 0)
+ 			{
+ 				/* Check for conflicted value. */
+ 				foreach(cell, partitions)
+ 				{
+ 					PartitionValues *part = (PartitionValues *) lfirst(cell);
+ 
+ 					for (i = 0; i < part->nvalues; i++)
+ 					{
+ 						for (j = 0; j < nvalues; j++)
+ 						{
+ 							if (DatumGetBool(FunctionCall2(&opfn,
+ 									part->values[i], values[j])))
+ 							{
+ 								elog(ERROR, "conflicted list partition values");
+ 							}
+ 						}
+ 					}
+ 				}
+ 
+ 				/* CHECK ( key = ANY ( values ) ) */
+ 				check_expr =
+ 					(Node *) makeA_Expr(AEXPR_IN, partopr, partkey,
+ 						(Node *) def->values, -1);
+ 			}
+ 			else
+ 			{
+ 				List *all_values = NIL;
+ 
+ 				/* Gather all values */
+ 				foreach(cell, partitions)
+ 				{
+ 					PartitionValues *part = (PartitionValues *) lfirst(cell);
+ 
+ 					for (i = 0; i < part->nvalues; i++)
+ 					{
+ 						Const *value = makeConst(elmtype, -1, elmlen,
+ 							part->values[i], false, elmbyval);
+ 						all_values = lappend(all_values, value);
+ 					}
+ 				}
+ 
+ 				/* CHECK ( NOT (key = ANY ( values ) ) ) */
+ 				if (all_values == NIL)
+ 					check_expr = NULL;
+ 				else
+ 					check_expr =
+ 						(Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
+ 							(Node *) makeA_Expr(AEXPR_IN, partopr, partkey,
+ 								(Node *) all_values, -1), -1);
+ 			}
+ 
+ 			break;
+ 		}
+ 		default:
+ 			elog(ERROR, "unknown partition kind: %d", def->kind);
+ 			check_expr = NULL;	/* keep compiler quiet */
+ 	}
+ 
+ 	/* Add partition constraint if needed */
+ 	if (check_expr != NULL)
+ 	{
+ 		Constraint	   *check;
+ 
+ 		check = makeNode(Constraint);
+ 		check->contype = CONSTR_CHECK;
+ 		check->location = -1;
+ 		check->raw_expr = check_expr;
+ 		check->cooked_expr = NULL;
+ 		ATAddCheckConstraint(wqueue, tab, child, check, false, false);
+ 	}
+ 
+ 	if (nvalues > 0)
+ 		return construct_array(values, nvalues,
+ 					elmtype, elmlen, elmbyval, elmalign);
+ 	else
+ 		return NULL;
+ }
+ 
+ /*
+  * evaluate_values - evaluate a list of expressions to build a datum array.
+  */
+ static Datum *
+ evaluate_values(Oid typid, int typlen, bool typbyval, List *values, int *length)
+ {
+ 	ListCell	   *cell;
+ 	ParseState	   *pstate;
+ 	EState		   *estate;
+ 	ExprContext	   *econtext;
+ 	int				i;
+ 	Datum		   *datum;
+ 
+ 	*length = list_length(values);
+ 	if (*length < 1)
+ 		return NULL;
+ 
+ 	datum = (Datum *) palloc(*length * sizeof(Datum));
+ 	pstate = make_parsestate(NULL);
+ 	estate = CreateExecutorState();
+ 	econtext = GetPerTupleExprContext(estate);
+ 
+ 	i = 0;
+ 	foreach(cell, values)
+ 	{
+ 		Node		   *value = (Node *) lfirst(cell);
+ 		bool			isnull;
+ 		ExprState	   *expr;
+ 		MemoryContext	oldcxt;
+ 
+ 		oldcxt = MemoryContextSwitchTo(GetPerTupleMemoryContext(estate));
+ 
+ 		value = transformExpr(pstate, value);
+ 		value = coerce_to_specific_type(pstate, value, typid, "PARTITION");
+ 		expr = ExecPrepareExpr((Expr *) value, estate);
+ 
+ 		datum[i] = ExecEvalExpr(expr, econtext, &isnull, NULL);
+ 		if (isnull)
+ 			elog(ERROR, "partition key must not be NULL");
+ 
+ 		MemoryContextSwitchTo(oldcxt);
+ 
+ 		if (!typbyval)
+ 		{
+ 			if (typlen == -1)
+ 				datum[i] = PointerGetDatum(PG_DETOAST_DATUM_COPY(datum[i]));
+ 			else
+ 				datum[i] = datumCopy(datum[i], false, typlen);
+ 		}
+ 
+ 		ResetPerTupleExprContext(estate);
+ 		i++;
+ 	}
+ 
+ 	FreeExecutorState(estate);
+ 	free_parsestate(pstate);
+ 
+ 	return datum;
+ }
+ 
+ /*
   * Obtain the source-text form of the constraint expression for a check
   * constraint, given its pg_constraint tuple
   */
*************** ATExecDropInherit(Relation rel, RangeVar
*** 7717,7722 ****
--- 8107,8185 ----
  
  
  /*
+  * ALTER TABLE PARTITION BY / NO PARTITION
+  */
+ static void
+ ATExecPartitionBy(Relation rel, PartitionBy *defs)
+ {
+ 	Oid				relid = RelationGetRelid(rel);
+ 	ObjectAddress	myself;
+ 
+ 	myself.classId = PartitionRelationId;
+ 	myself.objectId = relid;
+ 	myself.objectSubId = 0;
+ 
+ 	if (defs == NULL)
+ 	{
+ 		/* ALTER TABLE <name> NO PARTITION */
+ 		performDeletion(&myself, DROP_RESTRICT);
+ 	}
+ 	else
+ 	{
+ 		Relation		catalogRel;
+ 		TupleDesc		catalogDesc;
+ 		Datum			datum[Natts_pg_partition];
+ 		bool			nulls[Natts_pg_partition];
+ 		HeapTuple		tuple;
+ 		Node		   *partkey;
+ 		Oid				keytype;
+ 		Oid				partopr;
+ 		ParseState	   *pstate;
+ 		RangeTblEntry  *rte;
+ 
+ 		Assert(defs->key != NULL);
+ 		Assert(defs->opr != NIL);
+ 
+ 		/* Transform the expression of partition key. */
+ 		pstate = make_parsestate(NULL);
+ 		rte = addRangeTableEntryForRelation(pstate, rel, NULL, false, true);
+ 		addRTEtoQuery(pstate, rte, true, true, true);
+ 		partkey = transformExpr(pstate, defs->key);
+ 		free_parsestate(pstate);
+ 
+ 		/* Extract operator oid to compare partition keys */
+ 		keytype = exprType(partkey);
+ 		partopr = compatible_oper_opid(defs->opr, keytype, keytype, false);
+ 
+ 		/*
+ 		 * Make the pg_partition entry
+ 		 */
+ 		memset(nulls, 0, sizeof(nulls));
+ 		datum[0] = ObjectIdGetDatum(relid);			/* partrelid */
+ 		datum[1] = ObjectIdGetDatum(partopr);		/* partopr */
+ 		datum[2] = CharGetDatum(defs->kind);		/* partkind */
+ 		datum[3] = CStringGetTextDatum(nodeToString(partkey));	/* partkey */
+ 
+ 		catalogRel = heap_open(PartitionRelationId, RowExclusiveLock);
+ 		catalogDesc = RelationGetDescr(catalogRel);
+ 
+ 		tuple = heap_form_tuple(catalogDesc, datum, nulls);
+ 		simple_heap_insert(catalogRel, tuple);
+ 		CatalogUpdateIndexes(catalogRel, tuple);
+ 		heap_freetuple(tuple);
+ 
+ 		/* Store a dependency */
+ 		recordDependencyOnSingleRelExpr(&myself, partkey, relid,
+ 										DEPENDENCY_NORMAL, DEPENDENCY_AUTO);
+ 
+ 		heap_close(catalogRel, RowExclusiveLock);
+ 
+ 		/* Caller will create partition tables */
+ 	}
+ }
+ 
+ 
+ /*
   * Execute ALTER TABLE SET SCHEMA
   *
   * Note: caller must have checked ownership of the relation already
diff -cprN head/src/backend/nodes/copyfuncs.c work/src/backend/nodes/copyfuncs.c
*** head/src/backend/nodes/copyfuncs.c	2009-10-28 23:55:38.000000000 +0900
--- work/src/backend/nodes/copyfuncs.c	2009-11-05 12:11:45.983845439 +0900
*************** _copyCreateStmt(CreateStmt *from)
*** 2503,2508 ****
--- 2503,2509 ----
  	COPY_NODE_FIELD(options);
  	COPY_SCALAR_FIELD(oncommit);
  	COPY_STRING_FIELD(tablespacename);
+ 	COPY_NODE_FIELD(partitions);
  
  	return newnode;
  }
*************** _copyAlterTSConfigurationStmt(AlterTSCon
*** 3450,3455 ****
--- 3451,3506 ----
  	return newnode;
  }
  
+ static Partition *
+ _copyPartition(Partition *from)
+ {
+ 	Partition *newnode = makeNode(Partition);
+ 
+ 	COPY_SCALAR_FIELD(kind);
+ 	COPY_NODE_FIELD(name);
+ 	COPY_NODE_FIELD(values);
+ 	COPY_NODE_FIELD(options);
+ 	COPY_STRING_FIELD(tablespacename);
+ 
+ 	return newnode;
+ }
+ 
+ static PartitionBy *
+ _copyPartitionBy(PartitionBy *from)
+ {
+ 	PartitionBy *newnode = makeNode(PartitionBy);
+ 
+ 	COPY_SCALAR_FIELD(kind);
+ 	COPY_NODE_FIELD(key);
+ 	COPY_NODE_FIELD(opr);
+ 	COPY_NODE_FIELD(defs);
+ 
+ 	return newnode;
+ }
+ 
+ static CreatePartitionStmt *
+ _copyCreatePartitionStmt(CreatePartitionStmt *from)
+ {
+ 	CreatePartitionStmt *newnode = makeNode(CreatePartitionStmt);
+ 
+ 	COPY_NODE_FIELD(parent);
+ 	COPY_NODE_FIELD(def);
+ 
+ 	return newnode;
+ }
+ 
+ static AddInherit *
+ _copyAddInherit(AddInherit *from)
+ {
+ 	AddInherit *newnode = makeNode(AddInherit);
+ 
+ 	COPY_NODE_FIELD(parent);
+ 	COPY_SCALAR_FIELD(kind);
+ 	COPY_NODE_FIELD(values);
+ 
+ 	return newnode;
+ }
+ 
  /* ****************************************************************
   *					pg_list.h copy functions
   * ****************************************************************
*************** copyObject(void *from)
*** 4117,4122 ****
--- 4168,4185 ----
  		case T_AlterTSConfigurationStmt:
  			retval = _copyAlterTSConfigurationStmt(from);
  			break;
+ 		case T_Partition:
+ 			retval = _copyPartition(from);
+ 			break;
+ 		case T_PartitionBy:
+ 			retval = _copyPartitionBy(from);
+ 			break;
+ 		case T_CreatePartitionStmt:
+ 			retval = _copyCreatePartitionStmt(from);
+ 			break;
+ 		case T_AddInherit:
+ 			retval = _copyAddInherit(from);
+ 			break;
  
  		case T_A_Expr:
  			retval = _copyAExpr(from);
diff -cprN head/src/backend/nodes/equalfuncs.c work/src/backend/nodes/equalfuncs.c
*** head/src/backend/nodes/equalfuncs.c	2009-10-28 23:55:38.000000000 +0900
--- work/src/backend/nodes/equalfuncs.c	2009-11-05 12:11:46.040814773 +0900
*************** _equalCreateStmt(CreateStmt *a, CreateSt
*** 1101,1106 ****
--- 1101,1107 ----
  	COMPARE_NODE_FIELD(options);
  	COMPARE_SCALAR_FIELD(oncommit);
  	COMPARE_STRING_FIELD(tablespacename);
+ 	COMPARE_NODE_FIELD(partitions);
  
  	return true;
  }
*************** _equalAlterTSConfigurationStmt(AlterTSCo
*** 1900,1905 ****
--- 1901,1948 ----
  }
  
  static bool
+ _equalPartition(Partition *a, Partition *b)
+ {
+ 	COMPARE_SCALAR_FIELD(kind);
+ 	COMPARE_NODE_FIELD(name);
+ 	COMPARE_NODE_FIELD(values);
+ 	COMPARE_NODE_FIELD(options);
+ 	COMPARE_STRING_FIELD(tablespacename);
+ 
+ 	return true;
+ }
+ 
+ static bool
+ _equalPartitionBy(PartitionBy *a, PartitionBy *b)
+ {
+ 	COMPARE_SCALAR_FIELD(kind);
+ 	COMPARE_NODE_FIELD(key);
+ 	COMPARE_NODE_FIELD(opr);
+ 	COMPARE_NODE_FIELD(defs);
+ 
+ 	return true;
+ }
+ 
+ static bool
+ _equalCreatePartitionStmt(CreatePartitionStmt *a, CreatePartitionStmt *b)
+ {
+ 	COMPARE_NODE_FIELD(parent);
+ 	COMPARE_NODE_FIELD(def);
+ 
+ 	return true;
+ }
+ 
+ static bool
+ _equalAddInherit(AddInherit *a, AddInherit *b)
+ {
+ 	COMPARE_NODE_FIELD(parent);
+ 	COMPARE_SCALAR_FIELD(kind);
+ 	COMPARE_NODE_FIELD(values);
+ 
+ 	return true;
+ }
+ 
+ static bool
  _equalAExpr(A_Expr *a, A_Expr *b)
  {
  	COMPARE_SCALAR_FIELD(kind);
*************** equal(void *a, void *b)
*** 2810,2815 ****
--- 2853,2870 ----
  		case T_AlterTSConfigurationStmt:
  			retval = _equalAlterTSConfigurationStmt(a, b);
  			break;
+ 		case T_Partition:
+ 			retval = _equalPartition(a, b);
+ 			break;
+ 		case T_PartitionBy:
+ 			retval = _equalPartitionBy(a, b);
+ 			break;
+ 		case T_CreatePartitionStmt:
+ 			retval = _equalCreatePartitionStmt(a, b);
+ 			break;
+ 		case T_AddInherit:
+ 			retval = _equalAddInherit(a, b);
+ 			break;
  
  		case T_A_Expr:
  			retval = _equalAExpr(a, b);
